// lineedit.h
//
// LineEdit widget with command history
//
//   (C) Copyright 2015 Fred Gleason <fredg@paravelsystems.com>
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License version 2 as
//   published by the Free Software Foundation.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public
//   License along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#ifndef LINEEDIT_H
#define LINEEDIT_H

#include <QLineEdit>
#include <QStringList>

class LineEdit : public QLineEdit
{
 Q_OBJECT;
 public:
  LineEdit(QWidget *parent=0);
  void loadHistory(const QString &path);
  void saveHistory(const QString &path) const;

 protected:
  void keyPressEvent(QKeyEvent *e);

 private:
  QStringList edit_history;
  int edit_current_item;
  QString edit_current_text;
};


#endif  // LWCPMON_H
